require 'oauth2'
require 'omniauth'
module OmniAuth
  module Strategies
    class Frontrush
      include OmniAuth::Strategy
      uid do
        @raw_json['data']['Email']
      end
      credentials do
        { oauth_token: @raw_json['data']['Token'], oauth_token_secret: @raw_json['data']['TokenSecret'] }
      end
      extra do
        @raw_json['data']
      end
      def request_phase
        redirect get_redirect_url(callback_url + '?device=web', options)
      end

      def callback_phase
        puts "call back yo!!"
        optionshash = { consumer_key: options[:consumer_key], consumer_secret: options[:consumer_secret], token: nil, token_secret: nil }
        response = get_access_token(request, options, optionshash)
        super if get_json_from_response(response)
      end

      private

      def get_access_token(request, options, optionshash)
        url = set_request_url(request, options)
        uri = URI.parse(url)
        request = Net::HTTP::Get.new(URI.parse(url))
        ssl = (uri.scheme == "https")
        response = Net::HTTP.start(uri.host, uri.port,:use_ssl => ssl) do|http|
          http.request(request)
        end
      end

      def get_redirect_url(callback_url, options)
        options[:frontrush_url] + '/login.aspx?&consumer_key=' + options[:consumer_key] + '&callback=' + callback_url
      end

      def set_request_token(response)
        request_token = URI.escape(response.body)
        request_token = request_token.gsub("\"", '')
        env['rack.session'][:oauth_request_token] = request_token
        request_token
      end

      def get_json_from_response(response)
        @raw_json_string = response.body.slice(1, response.body.length - 2)
        @raw_json_string = @raw_json_string.gsub("\\\"", '"')
        begin
          @raw_json = JSON.parse(@raw_json_string)
        rescue Exception => e
          @raw_json = e.to_json
          return false
        end
        true
      end

      def set_request_url(request, options)
        oauth_consumer_key = options[:consumer_key]
        oauth_verifier = URI.escape(request.params['oauth_verifier'])
        request_path = '/oauth/access_token?oauth_verifier=' + oauth_verifier.to_s + '&oauth_consumer_key=' + oauth_consumer_key
        options[:frontrush_url] + request_path
      end
    end
  end
end
